function drawpythagorastree(N)
%DRAWPYTHAGORASTREE
%
%

% Author : Jerome Briot (Dut)
% Contact : dutmatlab@yahoo.fr -or- briot@cict.fr
% Profil : www.mathworks.com/matlabcentral/newsreader/author/94805
%        : www.developpez.net/forums/u125006/dut/
%
% Version : 1.0 - 07 Sep 2009
%

% MATLAB : 7.6.0.324 (R2008a)
% System : Linux 2.6.24-24-generic
%

if nargin == 0
    N = 10;
end

[v,th,L] = pythagorastree(N);

a = sqrt(2)/2;
xy = [0 -a 0 a 2*a 3*a 2*a; 0 a 2*a a 2*a a 0].';

col = flipud(summer(N+1));

figure('color','w','numbertitle','off')

vertices = [-.5 .5 .5 -.5 ; 0 0 1 1].';
patch('vertices',vertices,'faces',1:4,'facecolor',col(1,:),'edgecolor',col(1,:));

hold on

for n = 1:N
    
    xy = xy*L(n+1);

    for q = 1:size(v{n},1)

        temp = [xy ones(size(xy,1),1)] * [cos(th{n}(q)) sin(th{n}(q)) 0 ; -sin(th{n}(q)) cos(th{n}(q)) 0 ; v{n}(q,:) 1];
        patch('vertices',temp,'faces',[1:7 4],'facecolor',col(n+1,:),'edgecolor',col(n+1,:));

    end

end

str = sprintf('Pythagoras Tree (%d iterations)',N);
title(str)

axis equal off