function [v,th,L] = pythagorastree(N)
%PYTHAGORASTREE
%
%

% Author : Jerome Briot (Dut)
% Contact : dutmatlab@yahoo.fr -or- briot@cict.fr
% Profil : www.mathworks.com/matlabcentral/newsreader/author/94805
%        : www.developpez.net/forums/u125006/dut/
%
% Version : 1.0 - 07 Sep 2009
%

% MATLAB : 7.6.0.324 (R2008a)
% System : Linux 2.6.24-24-generic
%

error(nargchk(1,1,nargin));

a = sqrt(2)/2;
xy = [0 -a 0 a 2*a 3*a 2*a; 0 a 2*a a 2*a a 0].';

v{1} = [-.5 1];
th{1} = 0;
L = ones(1,N+1);

for n = 1:N
    L(n+1) = a;
    xy = xy*L(n+1);

    for q = 1:size(v{n},1)

        temp = [xy ones(size(xy,1),1)] * [cos(th{n}(q)) sin(th{n}(q)) 0 ; -sin(th{n}(q)) cos(th{n}(q)) 0 ; v{n}(q,:) 1];

        v{n+1}((q-1)*2+1,:) = temp(2,1:2);
        v{n+1}(2*q,:) = temp(5,1:2);

        th{n+1}((q-1)*2+1) = th{n}(q)+pi/4;
        th{n+1}(2*q) = th{n}(q)+-pi/4;

    end

end